# -*- encoding: utf-8 -*-
"Helper operations for the corresponding Makefile."

import os, subprocess, shlex

def p7zExtract(src, path, dist):
	cmd = [ "7z", "e", src, path, "-so", ]
	print(" ".join([shlex.quote(e) for e in cmd] + [ ">", dist, ]))
	with open(dist, "wb") as f:
		subprocess.check_call(cmd, stdout=f)
	
	# save md5
	distName = os.path.basename(dist)
	md5File = "repo/md5tmp.txt"
	cmd = [ "grep", "-e", r"\b" + distName + r"$", md5File, "-q", ]
	print(" ".join([shlex.quote(e) for e in cmd]))
	if subprocess.call(cmd) != 0:
		cmd = [ "md5sum", distName, ]
		print(" ".join([shlex.quote(e) for e in cmd] + [ ">>", os.path.basename(md5File), ]))
		with open(md5File, "ab") as f:
			subprocess.check_call(cmd, cwd=os.path.dirname(dist), stdout=f)

def p7zExtractImg(src, dist):
	srcItemName = dist.rsplit("-", 1)[-1].capitalize()
	srcItemPath = os.path.join(os.path.splitext(src)[0], srcItemName)
	p7zExtract(src, srcItemPath, dist)
